﻿Type=Class
Version=4.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Class module
Private Sub Class_Globals
	Private mb As Button
	Private mp As Panel
	Private bgd As GradientDrawable
	Private clr(2) As Int
	Private sclr(2) As Int
	Private animtimedown As Int = 300
	Private animtimeup As Int = 300
    Private Event As String
	Private gradientDirection As String = "TOP_BOTTOM"
	Private mbitmap As Bitmap
	Private rSize As Int = 5dip
	Private rt As String
	Private mbleft, mbtop, mbwidth, mbheight As Int
	Private mpleft, mptop, mpwidth, mpheight As Int
	
End Sub

'Initializes your class.
Public Sub Initialize(mybutton As Button, mypanel As Panel, left As Int, top As Int, width As Int, height As Int)

    mb = Null
	mb = mybutton
	mp = mypanel

	mb.left = left
	mb.top = top
	mb.width = width
	mb.height = width
	
	mbleft = mb.left
	mbtop = mb.top
	mbwidth = mb.width
	mbheight = mb.height
	
    mp.SendToBack
	
	Dim r As Reflector
	r.Target = mb
	r.SetOnClickListener("mb_onClick")
	mb.Invalidate
	mp.Invalidate

End Sub

Private Sub mb_onClick(ViewTag As Object)
	
    Select Case rt
	  Case "GROW_TO_SHADOW_AND_SHRINK"
		mb.SetLayoutAnimated(animtimedown, mp.Left, mp.Top , mp.Width, mp.Height)
		mb.Invalidate
	    mb.SetLayoutAnimated(animtimeup, mbleft, mbtop, mbwidth, mbheight)
	    mb.Invalidate		
	  Case "SHRINK_TO_ZERO_AND_GROW_RADIALLY"
		mb.SetLayoutAnimated(animtimedown, mp.Left + (mp.Width/2), mp.Top + (mp.Height/2), 1dip, 1dip)
		mb.Invalidate
	    mb.SetLayoutAnimated(animtimeup, mbleft, mbtop, mbwidth, mbheight)
	    mb.Invalidate		
	  Case "SHRINK_HORIZONTALLY_TO_ZERO_AND_GROW"
		mb.SetLayoutAnimated(animtimedown, mb.Left + (mb.Width/2), mb.Top, 0, mb.Height)
		mb.Invalidate
	    mb.SetLayoutAnimated(animtimeup, mbleft, mbtop, mbwidth, mbheight)
	    mb.Invalidate		
	  Case "SHRINK_VERTICALLY_TO_ZERO_AND_GROW"
		mb.SetLayoutAnimated(animtimedown, mb.Left, mb.Top + (mb.Height/2), mb.Width, 0)
		mb.Invalidate
	    mb.SetLayoutAnimated(animtimeup, mbleft, mbtop, mbwidth, mbheight)
	    mb.Invalidate		
	  Case "SHRINK_SHADOW_AND_GROW"
	    mpleft = mp.Left
		mptop = mp.Top
		mpwidth = mp.Width
		mpheight = mp.Height
		mp.SetLayoutAnimated(animtimedown, mb.Left, mb.Top, mb.Width, mb.Height)
		mp.Invalidate
		mb.Invalidate
	    mp.SetLayoutAnimated(animtimeup, mpleft, mptop, mpwidth, mpheight)
	    mp.Invalidate	
	  Case "GROW_SHADOW_AND_SHRINK"
	    mpleft = mp.Left
		mptop = mp.Top
		mpwidth = mp.Width
		mpheight = mp.Height
		mp.SetLayoutAnimated(animtimedown, mp.Left-rSize, mp.Top - rSize, mp.Width + (2 * rSize), mp.Height + (2 * rSize))
		mp.Invalidate
		mb.Invalidate
	    mp.SetLayoutAnimated(animtimeup, mpleft, mptop, mpwidth, mpheight)
	    mp.Invalidate				
	  End Select
      mp.Invalidate
	  mb.Invalidate
	  CallSub("Main", Event)


End Sub

Public Sub setButton

    'set the button
	bgd.Initialize(gradientDirection,clr)
	bgd.CornerRadius = mb.Width
	mb.Background = bgd

    Dim canvas1 As Canvas
    canvas1.Initialize(mb)

    Dim r1 As Rect
    Dim btnRect1 As Rect
	
    btnRect1.Initialize(0, 0, mb.Width, mb.Height)
    r1.Initialize(btnRect1.CenterX - 30dip, btnRect1.CenterY - 30dip, _
        btnRect1.CenterX + 30dip, btnRect1.CenterY + 30dip)
    canvas1.DrawBitmap(mbitmap, Null, r1)
	'*************************************************************************************
	
	'set the panel behind the button
	
	mp.Left = mb.Left - rSize
	mp.Top = mb.Top - rSize
	mp.Width = mb.Width + (2 * rSize)
	mp.Height = mb.Width + (2 * rSize)
	
	bgd.Initialize(gradientDirection,sclr)
	bgd.CornerRadius = mp.Width
	mp.Background = bgd

    Dim canvas2 As Canvas
    canvas2.Initialize(mp)

    Dim r2 As Rect
    Dim btnRect2 As Rect
	
    btnRect2.Initialize(0, 0, mp.Width, mp.Height)
    r2.Initialize(btnRect2.CenterX - 30dip, btnRect2.CenterY - 30dip, _
        btnRect2.CenterX + 30dip, btnRect2.CenterY + 30dip)
    canvas2.DrawBitmap(mbitmap, Null, r2)	
	
End Sub
Public Sub setButtonGradientColor(col1 As Int, col2 As Int)

clr(0) = col1
clr(1) = col2
	
End Sub
Public Sub setGradientDir (direct As String)

gradientDirection = direct

End Sub
Public Sub setBitMap (mbm As Bitmap)

mbitmap = mbm

End Sub

Public Sub Initialize2(CallbackModule As Object, EventName As String)

  Event = EventName
  
End Sub  
Public Sub setRingColor (shadow As Int)

sclr(0) = shadow
sclr(1) = shadow

End Sub

Public Sub setRingSize(size As Int)

rSize = size

End Sub
Public Sub setButtonReaction(reactionType As String)

rt = reactionType

End Sub




